<template>
  <form @submit.prevent="onFormSubmit();"
    v-if="showBrandList">
    <v-list v-for="store in storesList"
      :key="store.storeName"
      style="padding: 0px !important;">
      <v-list-tile style="padding: 0px !important;height: 35px !important;">
        <v-list-tile-content>
          <v-list-tile-title>
            {{ store.storeName }}
          </v-list-tile-title>
        </v-list-tile-content>
      </v-list-tile>
      <div style="background:#d3e1e8;padding: 10px;">
        <v-select
          v-model="store.brands"
          label="Add item brands here"
          chips
          tags
          solo
          prepend-icon="filter_list"
          append-icon=""
          clearable>
          <template slot="selection"
            slot-scope="data">
            <v-chip
              :selected="data.selected"
              close
              @input="remove(storesList.indexOf(store),data.item)">
              <strong>
                {{ data.item }}
              </strong>
              &nbsp;
            </v-chip>
          </template>
        </v-select>
        <div></div>
      </div>
      <span style="color:#FF6E40;padding-left:5%"
        v-if="storeBrandValid[storesList.indexOf(store)]">
        Required
      </span>
      <v-divider></v-divider>
    </v-list>
    <v-btn depressed
      v-if="storesList.length > 0"
      block
      color="darkSecondary"
      dark
      style="width:90%;margin:0 auto;margin-top:10px;"
      type="submit">
      NEXT
    </v-btn>
    <br/>
  </form>
</template>
<script>
export default {
  name: 'BrandRegistrationForm',
  data: () => ({
    storeBrandValid: []
  }),
  computed: {
    storesList () {
      return this.$store.state.itemRegistrationModule.storeList
    },
    showBrandList () {
      return !this.$store.state.itemRegistrationModule.brandFormValid
    }
  },
  methods: {
    remove (indexOfItem, item) {
      this.storesList[indexOfItem].brands.splice(this.storesList[indexOfItem].brands.indexOf(item), 1)
    },
    onFormSubmit () {
      let validForm = true
      this.storeBrandValid = []
      this.storesList.map(element => {
        if (element.brands.length > 0) {
          this.storeBrandValid.push(false)
        } else {
          this.storeBrandValid.push(true)
          validForm = false
        }
      })
      if (validForm === true) {
        this.$store.commit('BRAND_REGISTRATION_FORM_COMPLETE', this.storesList)
      }
    }
  }
}
</script>
<style scoped>
.card__title{
  padding: 10px !important;
}
.list__tile{
  height: 0px !important;
}
</style>
